#include <xc.h>
#include "ADC.h"

void ADC_Init(void)
{
	VREFCON0bits.FVRS=0b10;	// Fixed Voltage Reference Peripheral output is 2x (2.048V)
	VREFCON0bits.FVREN=1;	// Fixed Voltage Reference is enabled
	ADCON1bits.PVCFG=0b00;	// Vref+: Vdd
	ADCON1bits.NVCFG=0b00;	// Vref-: Vss
	ADCON2=0b10101110;		// Right Justified, Acqusiton: 12TAD, Clock: Fosc/64
	ADCON0bits.ADON=1;		// Enable ADC
}

int ADC_Read(unsigned char channel)
{
	int result;	
	ADCON2bits.ADFM=1; 		// Right Justified
	ADCON0=((channel<<2)&0b01111100);
	ADCON0bits.ADON=1;
	
	ADCON0bits.GO_DONE=1;
	while(ADCON0bits.GO_DONE == 1);	
	result=ADRES;
	ADCON0bits.ADON=0;
	
	return result;
}

void ADC_Sampel(unsigned char channel)
{
	int result;	
	ADCON2bits.ADFM=1; 		// Right Justified
	ADCON0=((channel<<2)&0b01111100);
	ADCON0bits.ADON=1;	
	ADCON0bits.GO_DONE=1;
}

unsigned char ADC_Read_8bit(unsigned char channel)
{
	int result;
	ADCON2bits.ADFM=0; 		// Left Justified
	ADCON0=((channel<<2)&0b01111100);
	ADCON0bits.ADON=1;

	ADCON0bits.GO_DONE=1;
	while(ADCON0bits.GO_DONE == 1);
	ADCON0bits.ADON=0;
	return ADRESH;
}

void ADC_Sampel_8bit(unsigned char channel)
{
	ADCON2bits.ADFM=0; 		// Left Justified
	ADCON0=((channel<<2)&0b01111100);
	ADCON0bits.ADON=1;

	ADCON0bits.GO_DONE=1;
}
		