#include <xc.h>
#include "PWM.h"

void PWM1_Init(void)
{
	CCPTMRS0bits.C1TSEL1=0;
	CCPTMRS0bits.C1TSEL0=0;		// CCP1 PWM modes use Timer2
	
	PR2=0x3F;					// PWM Frequency = 250 kHz @ 64MHz

	CCP1CONbits.P1M1=0;			
	CCP1CONbits.P1M0=0;			// Single output; PxA modulated; PxB, PxC, PxD assigned as port pins	
	CCP1CONbits.CCP1M3=1;
	CCP1CONbits.CCP1M2=1;
	CCP1CONbits.CCP1M1=0;
	CCP1CONbits.CCP1M0=0;		// PWM mode: PxA, PxC active-high; PxB, PxD active-high
	
	CCPR1L=0x20;
	CCP1CONbits.DC1B1=0;
	CCP1CONbits.DC1B0=0;		// Duty Cycle 50%
	
	PIE1bits.TMR2IE=0;			// Disable Timer 2 Interrupt
	
	T2CONbits.T2OUTPS3=0;
	T2CONbits.T2OUTPS2=0;
	T2CONbits.T2OUTPS1=0;
	T2CONbits.T2OUTPS0=0;		// 1:1 Postscaler
	T2CONbits.TMR2ON=1;			// Timer 2 on
	T2CONbits.T2CKPS1=0;
	T2CONbits.T2CKPS0=0;		// Prescaler is 1	
}

void PWM1_Set_DC(unsigned char dc)	//255 --> 100%		0 --> 0%
{	
	CCPR1L=dc>>2;
	CCP1CONbits.DC1B1=(dc>>1)&0x01;
	CCP1CONbits.DC1B0=dc&0x01;		// Duty Cycle 0%
}	
