#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
#include "ADC.h"
#include "PWM.h"

#pragma config FOSC = INTIO7, PLLCFG = ON //FOSC = Internal PLL = ON
#pragma config PWRTEN = OFF, BOREN=SBORDIS, BORV = 250
#pragma config WDTEN = OFF

#define _XTAL_FREQ 64000000

int main()
{
    OSCCONbits.IRCF= 0b111;     //HFINTOSC 	16MHz
    OSCCONbits.SCS = 0b00;      //Primary clock (determined by FOSC<3:0> in CONFIG1H
    OSCTUNEbits.PLLEN=1;        //PLL enabled

    ANSELD=0x00;
    TRISD=0x00;
    LATD=0x00;

	ANSELC=0x00;

	TRISCbits.TRISC2=0;		// RC2/CCP1 Output
	PWM1_Init();


	TRISAbits.TRISA0=1;		// AN0/RA0 Input
	ANSELAbits.ANSA0=1;		// AN0/RA0 Analog
	ADC_Init();

	ADC_Sampel_8bit(0);		// AN0/RA0

    RCONbits.IPEN=1;		// Enable Interrupt priority
	INTCONbits.GIEL=1;
    INTCONbits.GIE=1;		// Enable Interrupts

	T0CONbits.T08BIT=0;		// Timer 0 16 bit mode
	T0CONbits.T0CS=0;		// Internal instruction cycle clock
	T0CONbits.PSA=1;		// Timer0 prescaler is NOT assigned
	//T0CONbits.PSA=0;		// Timer0 prescaler is assigned
	T0CONbits.T0PS2=0;
	T0CONbits.T0PS1=0;
	T0CONbits.T0PS0=1;		// Prescaler 1:4;
	T0CONbits.TMR0ON=1;		// Timer 0 ON

	INTCON2bits.TMR0IP=1;	// High Priority
	INTCONbits.TMR0IF=0;	// Clear Timer 0 Interrupt Flag
	INTCONbits.TMR0IE=1;	// Enabel Timer 0 Interrupt


    while(1);
}

void interrupt high_isr(void)
{
	if(	INTCONbits.TMR0IF)
	{
		TMR0H=0xFE;
		TMR0L=0xC1;
		INTCONbits.TMR0IF=0;	// Clear Timer 0 Interrupt Flag
		PWM1_Set_DC(ADRESH);
		LATD=ADRESH;
		ADC_Sampel_8bit(0);		// AN0/RA0
	}
}


void interrupt low_priority low_isr(void)
{
}